#mycopico_pins.py

import machine
import utime
import math

import mycopico_convert

led1Pin = machine.Pin(4, machine.Pin.OUT) #Pico6 - i.e. GP4 =board6
led2Pin = machine.Pin(3, machine.Pin.OUT) #Pico5
led3Pin = machine.Pin(2, machine.Pin.OUT) #Pico4
led4Pin = machine.Pin(1, machine.Pin.OUT) #Pico2
ledPWMPin = machine.PWM(machine.Pin(0))
ledPWMPin.freq(1000)

S1Pin = machine.Pin(12, machine.Pin.IN, machine.Pin.PULL_UP) #Pico16
S2Pin = machine.Pin(11, machine.Pin.IN, machine.Pin.PULL_UP) #Pico15
RSPin = machine.Pin(10, machine.Pin.IN, machine.Pin.PULL_UP) #Pico14

D0Pin = machine.Pin(9, machine.Pin.IN, machine.Pin.PULL_UP) #Pico12
D1Pin = machine.Pin(8, machine.Pin.IN, machine.Pin.PULL_UP) #Pico11
D2Pin = machine.Pin(7, machine.Pin.IN, machine.Pin.PULL_UP) #Pico10
D3Pin = machine.Pin(6, machine.Pin.IN, machine.Pin.PULL_UP) #Pico9

sensor_1 = machine.ADC(26) #Pico31
sensor_2 = machine.ADC(27)#Pico32
sda = machine.Pin(18) #Pico24
scl = machine.Pin(19) #Pico25

def out(data):
	led1Pin.value(0)
	led2Pin.value(0)
	led3Pin.value(0)
	led4Pin.value(0)
	if data==('0'):
		led1Pin.value(0)
	if data==('1'):
		led1Pin.value(1)
	if data==('2'):
		led2Pin.value(1)
	if data==('3'):
		led1Pin.value(1)
		led2Pin.value(1)
	if data==('4'):
		led3Pin.value(1)
	if data==('5'):
		led1Pin.value(1)
		led3Pin.value(1)
	if data==('6'):
		led2Pin.value(1)
		led3Pin.value(1)
	if data==('7'):
		led1Pin.value(1)
		led2Pin.value(1)
		led3Pin.value(1)
	if data==('8'):
		led4Pin.value(1)
	if data==('9'):
		led1Pin.value(1)
		led4Pin.value(1)
	if data==('A'):
		led2Pin.value(1)
		led4Pin.value(1)
	if data==('B'):
		led1Pin.value(1)
		led2Pin.value(1)
		led4Pin.value(1)
	if data==('C'):
		led3Pin.value(1)
		led4Pin.value(1)
	if data==('D'):
		led1Pin.value(1)
		led3Pin.value(1)
		led4Pin.value(1)
	if data==('E'):
		led2Pin.value(1)
		led3Pin.value(1)
		led4Pin.value(1)
	if data==('F'):
		led1Pin.value(1)
		led2Pin.value(1)
		led3Pin.value(1)
		led4Pin.value(1)
	if data==('i1'):
		led1Pin.value(1)
	if data==('i0'):
		led1Pin.value(0)
	if data==('ii1'):
		led2Pin.value(1)
	if data==('ii0'):
		led2Pin.value(0)
	if data==('iii1'):
		led3Pin.value(1)
	if data==('iii0'):
		led3Pin.value(0)
	if data==('iv1'):
		led4Pin.value(1)
	if data==('iv0'):
		led4Pin.value(0)

def AD1():
	reading = sensor_1.read_u16()
	voltage = (reading / 65535) * 3.3
	print ('ADC0 Value : %d, Voltage : %.2f'%(reading,voltage))
#	reading=3.3-voltage#PCF8591 reads voltage across LDR; Juergen requires voltage across other resistor
	value=math.floor((voltage/3.3)*16)
	value=mycopico_convert.hex_from_decimal(value)
	return value
	
def AD2():
	reading = sensor_2.read_u16()
	voltage = (reading / 65535) * 3.3
	print ('ADC1 Value : %d, Voltage : %.2f'%(reading,voltage))
#	reading=3.3-voltage#PCF8591 reads voltage across LDR; Juergen requires voltage across other resistor
	value=math.floor((voltage/3.3)*16)
	value=mycopico_convert.hex_from_decimal(value)
	return value
	
def D0():#input switch 0
	if D0Pin.value() == 0:
		value='0'
	else:
		value='1'
	return value

def D1():#input switch 1
	if D1Pin.value() == 0:
		value='0'
	else:
		value='1'
	return value

def D2():#input switch 2
	if D2Pin.value() == 0:
		value='0'
	else:
		value='1'
	return value

def D3():#input switch 3
	if D3Pin.value() == 0:
		value='0'
	else:
		value='1'
	return value

def DI():#input switches 0-3
	value=mycopico_convert.bin_to_hex(D3()+D2()+D1()+D0())
	return value

def S1():#button 1
	if S1Pin.value() == 0:
		value='0'
	else:
		value='1'
	return value

def S2():#button 2
	if S2Pin.value() == 0:
		value='0'
	else:
		value='1'
	return value

def RS():#reset
	if RSPin.value() == 0:
		value='0'
	else:
		value='1'
	return value

def _PWM(data):
	data=float(mycopico_convert.hex_to_decimal(data))
	data=((data/16)**2)*65535
	data=int(data)
	ledPWMPin.duty_u16(data)

def control():
	pot=(machine.ADC(28))#Pico34
	reading = pot.read_u16()#clockwise for big delay
	reading*=255/65535
	if reading > 240:
		value=0
	elif reading > 200:
		value=0.5 
	elif reading > 160:
		value=1
	elif reading > 120:
		value=2	
	elif reading > 80:
		value=5
	elif reading > 40:
		value=10	
	elif reading <= 40:
		value=30	
	return value

def clear():
	led1Pin.value(0)
	led2Pin.value(0)
	led3Pin.value(0)
	led4Pin.value(0)
	_PWM('0')

def LED_test():
	led1Pin.value(1)
	led2Pin.value(0)
	led3Pin.value(1)
	led4Pin.value(0)
	print ('...led 1&3')
	utime.sleep(1)	
	led1Pin.value(0)
	led2Pin.value(1)
	led3Pin.value(0)
	led4Pin.value(1)
	print ('led 2&4')
	utime.sleep(1)
	led2Pin.value(0)
	led4Pin.value(0)
	utime.sleep(0.5)
	print("PWM...")
	_PWM('F')  
	utime.sleep(1)
	_PWM('7')
	utime.sleep(1)
	_PWM('1')
	utime.sleep(1)
	_PWM('0')
	if D0Pin.value() == 1:
		led1Pin.value(1)
	if D1Pin.value() == 1:
		led2Pin.value(1)		
	if D2Pin.value() == 1:
		led3Pin.value(1)		
	if D3Pin.value() == 1:
		led4Pin.value(1)		
	utime.sleep(1)
	
if __name__ == '__main__':
	if RSPin.value() == 1:
		LED_test()
		utime.sleep(2)
	print("S2: ",S2Pin.value())
	print("S1: ",S1Pin.value())
	value = DI()
	print("DI:",value)
	control()
	clear()